#!/usr/local/bin/perl
#####################################################################
# ChatPro Lurk Script Version 2.5                                   #
#                                                                   #
# by Command-O Software                                             #
# http://www.command-o.com                                          #
#                                                                   #
# Copyright 1998, All Rights Reserved                               #
#                                                                   #
# By using this script Licensee agrees to all terms of the License  #
# Agreement. Read it now, if you haven't already.                   #
#####################################################################
$conf_file = "chatpro.conf";
$default_lang_file = "chatpro.lang";
$chatpro_url = "http://www.command-o.com/cgi-bin/chatpro.cgi";


$join_room = "Join Room";
$refresh_time = 30;
#####################
$script_name = $ENV{'SCRIPT_NAME'};
$ENV{'SCRIPT_NAME'} = $chatpro_url;
$lang_file = $default_lang_file;
require("$conf_file");
@pairs = split(/&/, $ENV{'QUERY_STRING'});

foreach $pair (@pairs) {
   ($nam, $value) = split(/=/, $pair);
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;
   if($allow_html == 0) {
      $value =~ s/</&lt;/g;
      $value =~ s/>/&gt;/g;
   }
   $FORM{$nam} = $value;
}
if($FORM{'where'} eq "$join_room") {
   print "Location: $chatpro_url?$FORM{'room'}\n\n";
   exit;
}
if($FORM{'room'}) {
   $room = $FORM{'room'};
}
if($FORM{'priroom'}) {
   $room = $FORM{'priroom'};
}
elsif($FORM{'pubroom'}) {
   $room = $FORM{'pubroom'};
}
if($room eq "" || !$room) {
   $room = $entry;
}
$room =~ s/ /_/g;
if($FORM{'nummes'}) {
   $nummes = $FORM{'nummes'};
}
else {
   $nummes = $def_mes;
}
if($nummes =~ /^\d+$/ && $nummes > $max_mes) {
   $nummes = $max_mes;
}
$time = time();
sub set_values {
   $visitors_time = $visitors_time * 60;
   $chat_time = $chat_time * 60;
}

if (-e "$plugin_dir/plugin.conf") {
   require("$plugin_dir/plugin.conf");
}
if($custom_room_plugin) {
   require("$plugin_dir/custom_room.pl");
   &custom_room;
}
require("$lang_file") || die "Could not find language file";
&misc_lang;
&main_page_lang;
$our_link = "http://www.command-o.com/";
$our_image = "<font size=-1>ChatPro 2.5 by <a href=\"$our_image\" target=\"_new\">Command-O Software</a></font>";

if($ad_file && $ad_locations) {
   require("$plugin_dir/advertise.pl");
}

open(MAIN,"$file_dir/chat$room");
if($nummes =~ /^$all_nummes$/i) {
   @main = <MAIN>;
}
elsif($nummes =~ /^$new_nummes$/i) {
   $new_time = $FORM{'load_time'} - $new_time;
   while($newmain == 0) {
      $newline = <MAIN>;
      ($bogus,$linetime) = split(/:/,$newline);
      if ($linetime >= $new_time) {
         push(@main,$newline);
      }
      else {
         $newmain = 1;
      }
      undef($linetime);
   }
}
elsif($nummes =~ /^\d+$/) {
   while($linecount < $nummes) {
      push(@main,<MAIN>);
      $linecount++;
   }
}
else {
   while($linecount < $def_mes) {
      push(@main,<MAIN>);
      $linecount++;
   }
}
close(MAIN);

open(VISITORS,"$file_dir/vis$room");
@visitors = <VISITORS>;   
close(VISITORS);

if($ENV{'HTTP_HOST'}) {
   print "Refresh: $refresh_time;URL=http://$ENV{'HTTP_HOST'}";
   print "$script_name?room=$room&load_time=$time&nummes=$nummes\n";
}
else {
   print "Refresh: $refresh_time;URL=$ENV{'HTTP_REFERER'}";
   print "?room=$room&load_time=$time&nummes=$nummes\n";
}
print "Content-type: text/html\n\n";
   
print "<html><head><title>$page_title</title>\n";
   
print "</head><body bgcolor=$bgcolor background=\"$background\"";
print " text=$text_color link=$link_color vlink=$vlink_color>\n";
print "<form method=get action=\"$script_name\">\n";
print "<center>\n";
   
if($advertise_plugin && $ad_file && $ad_locations =~ /c/) {
   &advertise;
}
   
print "<table border=$border width=100%><tr valign=top>\n";      
if($advertise_plugin && $ad_file && $ad_locations =~ /d/) {
   print "<td rowspan=3>\n";
   &advertise;
   print "</td>\n";
}
print "<td rowspan=3><center>\n";
if (!$title_graphic) {
   print "<H3>$page_title</h3>\n";
}
else {
   print "<img src=\"$title_graphic\" border=0 ";
   print "alt=\"$page_title\"><br>\n";
}
$curroom = $room;
$curroom=~ s/_/ /g;
print "$currently_in <b>$curroom</b>\n";
print "<select>\n";
print "<option>$whos_here\n";
foreach$visline(@visitors) {
   $vislinet = $visline;
   $vislinet =~ s/<!--(.|\n)*-->//g;
   print "<option>$vislinet\n";
}
print "</select><input type=\"submit\" name=\"where\" value=\"$join_room\"><br>\n";

print "<select name=\"pubroom\">\n";    
print "<option value=\"\">$pub_room_title\n";
foreach$public_room(@public_rooms) {
   print "<option>$public_room\n";
}
print "</select>\n";
if($allow_private) {
   print "&nbsp; $pri_room_title\n";
   print "<input type=text size=15 name=\"priroom\">\n";
}
print "<input type=\"hidden\" name=\"load_time\" value=\"$time\">\n";
print "<input type=\"hidden\" name=\"room\" value=\"$room\">\n";
print "<input type=submit name=\"where\" value=\"$go_there\">\n";

print "&nbsp;&nbsp;$nummes_a <input type=text name=\"nummes\" ";
print "value=\"$nummes\" size=3 maxlength=3> $nummes_b\n";

print "</td></tr></table></center></form>\n";
   
if($advertise_plugin && $ad_file && $ad_locations =~ /e/) {
   &advertise;
   print "<hr>";
}

print "<a name=\"messages\">\n";
   
foreach$line(@main) {
   ($bogus,$clinetime) = split(/:/,$line);
   if($clinetime > $FORM{'load_time'}) {
      print "$new_message $line";
   }
   elsif(!$old_timer) {
      $old_timer = 1;
      print "<font color=$oldcolor>\n";
      print $line;
   }
   else {
      print $line;
   }
}
   
if($advertise_plugin && $ad_file && $ad_locations =~ /f/) {
   &advertise;
}
   
print "<center>$our_image</center>\n";
print "</body> </html>\n";
