#####################################################################
# ChatPro Registration Part Version 2.5                             #
# register.pl                                                       #
#                                                                   #
# by Command-O Software                                             #
# http://www.command-o.com                                          #
#                                                                   #
# Copyright 1997-98, All Rights Reserved                            #
#                                                                   #
# By using this script Licensee agrees to all terms of the License  #
# Agreement. Read it now, if you haven't already.                   #
#####################################################################
# Set Variables
$register_button = "Register";
$confirm_blank = "Confirmation Number:";

sub main_page_header {
   print "<center><h2>Registration</h2></center>\n";
   print "To use the chat you must register first.\n";
   print "It is a painless and quick procedure.<p>\n";
   
   print "If you are already registered and know your name and password\n";
   print " you can <a href=\"$ENV{'SCRIPT_NAME'}\">enter the chat</a> right now.<p><hr>\n";
   

   print "If you are new here you need to tell us your name, email address,\n";
   print "and choice of password so we can set you up. Your email address\n";
   print "will be used to send you a confirmation number. We will not use it\n";
   print "for any other purpose. You may use an alias if you are not comfortable\n";
   print "using your real name. Choose any password you wish, be sure to write it down.<p>\n";
}

sub confirm_page_header {
   print "<center><h2>Application Processed</h2></center>\n";
   print "Your application has been processed.<p>\n";
   print "You have been e-mailed your confirmation number.\n";
   print "It should arrive momentarily.<p>\n";
   print "When it arrives fillout this form:<p>\n";
}

sub incorrect_page {
   print "<center><h2>Incorrect Information</h2></center>\n";
   print "We're sorry your request could not be processed.<p>\n";
   print "Your combination of name, password, and confirmation number were\n";
   print "not found in our records.<p>\n";
   print "Use the back button \n";
   print "to return to the previous page. If you made a typo in your submission correct it.\n";
   print "If you have not applied for a confirmation number fill out that part of the form.<p>\n";
}

sub unmatching_passwords {
   print "<center><h2>Unmatching Passwords</h2></center>\n";
   print "We're sorry your request could not be processed.<p>\n";
   print "The two passwords you entered were not identical.<p>\n";
   print "Use the back button to return to the previous page.\n";
   print "Retype your password in both fields and submit the form again.<p>\n";
}

sub banned_address {
   print "<center><h2>Banned E-Mail Address</h2></center>\n";
   print "We're sorry, you have been banned from participating\n";
   print "in this chat.<p>\n";
}

sub name_in_use {
   print "<center><h2>Name Already In Use</h2></center>\n";
   print "The name you requested is already being used.<p>\n";
   print "Use the back button to return to the previous page.\n";
   print " Choose a new name and submit the form again.<p>\n";
}

sub too_many_accounts {
   print "<center><h2>Too Many Accounts</h2></center>\n";
   print "Chat users can register up to $account_limit different Chat\n";
   print "accounts on one e-mail address.  You have already reached the limit.<p>\n"; 
}

sub missing_info_text {
   print "<center><h2>Missing Information</h2></center>\n";
   print "We're sorry your request could not be processed.<p>\n";
   print "You must fill out every field in the form you are submitting.<p>\n";
   print "Use the back button to return to the previous page.<p>\n";
}

sub mail_message_header {
   print MAIL "Hello,\n\n";
   
   print MAIL "Thank you for using our chat.\n\n";
   
   print MAIL "To use the chat you must enter the following information\n";
   print MAIL "along with the password you chose in the form at ";
}

sub mail_message_footer {
   print MAIL "You have 72 hours to complete the registration process or you'll\n";
   print MAIL "need to start over.\n";
}
# Done
#####################################################################
# CHANGING ANYTHING BELOW THIS LINE WITHOUT THE EXPRESS PERMISSION  #
#  OF COMMAND-O SOFTWARE IS A VIOLATION OF THE LICENSE AGREEMENT    #
#####################################################################

sub reg_page_header {
   print "Content-type: text/html\n\n";
   
   print "<html><head><title>$page_title $reg_page</title></head>\n";
   print "<body bgcolor=$bgcolor background=\"$background\" ";
   print "text=$text_color link=$link_color vlink=$vlink_color>\n";
   if($font_face ne "") {
      print "<font face=\"$font_face\">\n";
   }
   print "<ul><center>\n";
   
   if($advertise_plugin && $ad_locations =~ /a/) {
      require("$plugin_dir/advertise.pl");
      &advertise;
   }

   if ($title_graphic eq "") {
      print "<H1>$page_title</h1>\n";
   }
   else {
      print "<h1><img src=\"$title_graphic\" alt=\"$page_title\"></h1>\n";
   }
   print "</center>\n";

}

sub reg_page_footer {
   if($advertise_plugin && $ad_locations =~ /b/) {
      require("$plugin_dir/advertise.pl");
      &advertise;
   }

   print "<center>$our_image</center>\n";
   print "</body> </html>\n";
   &unlock;
   exit;

}
require($lang_file);
&reg_page_lang;
$expiry_time = $expiry_time * 3600;
if($ENV{'CONTENT_LENGTH'}) {
   &parse_form;
   &get_variables;
   if($regno && $name && $password) {
      &check_tempfile;
      &edit_password_file;
      &send_to_chat;
   }
   elsif ($name && $mail && $password && $passwordb) {
      &process_info;
      &add_to_tempfile;
      &email;
      &confirm_html;
   }
   else {
      &missing_info;
   }
}

elsif($ENV{'QUERY_STRING'} eq "register_confirm") {
   &confirm_html;
}
else {
   &return_html;
}
exit;

sub return_html {

   &reg_page_header;
      
   &main_page_header;
   
   print "<form method=post action=\"$ENV{'SCRIPT_NAME'}?register\">\n";
   print "<table><tr><td>$name_blank</td>\n";
   print "<td><input type=text size=30 name=\"name\" ";
   print "maxlength=25><br></td></tr>\n";
   print "<tr><td>$passwd_blank</td>\n";
   print "<td><input type=password name=\"password\" size=30>\n";
   print "<br></td></tr>\n";
   print "<tr><td>$passwd_blank</td>\n";
   print "<td><input type=password name=\"passwordb\" size=30>\n";
   print "<br></td></tr>\n";
   print "<tr><td>$mail_blank</td>\n";
   print "<td><input type=text size=30 name=\"mail\"><br></td></tr>\n";
   print "</table>\n";
   print "<input type=submit value=\"$register_button\">\n";

   print "</form>\n";

   &reg_page_footer;
}

sub confirm_html {
   &reg_page_header;
    
   &confirm_page_header;
   
   print "<form method=post action=\"$ENV{'SCRIPT_NAME'}?register\">\n";
   print "<table><tr><td>$name_blank</td>\n";
   print "<td><input type=text size=30 name=\"name\" ";
   print "maxlength=25><br></td></tr>\n";
   print "<tr><td>$passwd_blank</td>\n";
   print "<td><input type=password name=\"password\" size=30>\n";
   print "<br></td></tr>\n";
   print "<tr><td>$confirm_blank</td>\n";
   print "<td><input type=text name=\"regno\" size=30>\n";
   print "<br></td></tr>\n";
   print "</table>\n";
   print "<input type=submit value=\"$register_button\">\n";
   print "</form><p><hr>\n";

   &reg_page_footer;
}

sub check_tempfile {
   $passwordc = crypt($password,MW);
   open(FILE,"$tempfile");
   @file = <FILE>;
   close(FILE);
   $linetotal = @file;
   $linecount = 0;
   while($linecount < $linetotal) {
      ($regnof,$namef,$passwordf,$mailf,$addtime) = split(/::/,$file[$linecount]);
      if($regno eq "$regnof" && $name =~ /^$namef$/i && $passwordc eq $passwordf) {
         $match = 1;
         $mail = $mailf;
         undef $file[$linecount];
      }
      if(time() - $addtime > $expiry_time) {
         undef $file[$linecount];
         $deleted = 1;
      }
      $linecount++;
   }
   if($match || $deleted) {
      open(FILE,">$tempfile");
      foreach$line(@file) {
         print FILE "$line";
      }
      close(FILE);
   }
   if(!$match) {
      &reg_page_header;
         
      &incorrect_page;

      &reg_page_footer;
   }   
}

sub edit_password_file {
   open(PFILE,">>$password_file") || die;
   print PFILE "$name\::$passwordc\::$mail\::\n";
   close(PFILE);
}

sub send_to_chat {
   if($ad_locations =~ /a|b/ && $advertise_plugin) {
      require("$plugin_dir/advertise.pl");
   }
   $room = $entry;
   &login;
   &unlock;
   exit;
}

sub process_info {
   if($password ne $passwordb) {
      &reg_page_header;
      
      &unmatching_passwords;
      
      &reg_page_footer;
   }
   open(BANNED,"$banned_list");
   while(<BANNED>) {
      if($_ eq "$mail\n") {
         &reg_page_header;

         &banned_address;
         
         &reg_page_footer;
      }
   }
   close(BANNED);
   
   open(PFILE,"$password_file");
   while(<PFILE>) {
      if($_ =~ /^$name\::/i) {
         &reg_page_header;

         &name_in_use;

         &reg_page_footer;
      }
      if($_ =~ /$mail/) {
         $account_count++;
      }
   }
   close(PFILE);
   
   if($account_count > $account_limit) {
      &reg_page_header;
      
      &too_many_accounts;
      
      &reg_page_footer;
   }
   $passwordc = crypt($password,MW);
   $addtime = time();
   $regnot = substr($addtime,-7,7);
}

sub add_to_tempfile {
  open(FILE,">>$tempfile") || die;
  print FILE "$regnot\::$name\::$passwordc\::$mail\::$addtime\n";
  close(FILE);
}

sub email {
   open(MAIL,"|$sendmail -t") || die "Couldn't open Sendmail";
   print MAIL "To: $mail\n";
   print MAIL "From: $mailfrom\n";
   print MAIL "Organization: Auto-Sent Mail\n";
   print MAIL "Subject: $mail_subject\n";
   print MAIL "X-Courtesy-Of: Check Mail\n\n";

   &mail_message_header;
   
   print MAIL " http://$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}?register_confirm\n\n";

   print MAIL "$name_blank $name\n";
   print MAIL "$confirm_blank $regnot\n\n";

   &mail_message_footer;
   close (MAIL);
}

sub missing_info {
   &reg_page_header;
   
   &missing_info_text;
      
   &reg_page_footer;
}
############################################
# DO NOT CHANGE THE LAST LINE OF THIS FILE #
############################################
1;
