#####################################################################
# ChatPro Admin Part Version 2.5                                    #
# admin.pl                                                          #
#                                                                   #
# by Command-O Software                                             #
# http://www.command-o.com                                          #
#                                                                   #
# Copyright 1997-98, All Rights Reserved                            #
#                                                                   #
# By using this script Licensee agrees to all terms of the License  #
# Agreement. Read it now, if you haven't already.                   #
#####################################################################
sub admin_lang {

   $bad_password = "The password you entered was incorrect.<p>Or possibly you are not set up as an administrator.<p>Nothing will be done.<p> Use the back button,  delete the command and continue as normal.";

   $edit_commands = "Make your changes to commands in the field below and submit the form.";
   $edit_button = "Change Commands";
   $return_text = "Return to Chat";
   $commands_edited = "The commands have been edited. Use the back button twice, and resume as normal.";
   
   $will_be_moderated = "will be moderated for";
   $moderated_minutes = "minutes";
   $moderated_until = "will be moderated until the commands are edited.";
   $moderator_is = "The moderator is";
   $moderatee_is = "The moderatee is";
   $other_posts = "If anyone else attempts to post a public message it will be sent to";
   $only_one_on_one = "The moderator is the only person who can send one on ones to";

   $command_added = "The administration command you requested was added to the list of commands and will be executed when the specified person runs the script.<p>Use the back button and continue as normal.";
}
#####################################################################
# CHANGING ANYTHING BELOW THIS LINE WITHOUT THE EXPRESS PERMISSION  #
#  OF COMMAND-O SOFTWARE IS A VIOLATION OF THE LICENSE AGREEMENT    #
#####################################################################
sub check_admin {
   open(PASSTEST,"$password_file");
   while(<PASSTEST>) {
      $line = $_;
      $line =~ s/\n//g;
      ($listname,$listpass,$bogus,$adminok) = split(/::/,$line);
      if($adminok eq "admin" && $listpass eq $password && $listname eq $name) {
         $adminyes = 1;
      }      
   }
   close(PASSTEST);
}

sub admin_work {
   &admin_lang;
   
   $message =~ s/ <br> /\n/g;

   (@command) = split(/\n/,$message);
   ($bogus,$apassword,$adname,$change,$comtime,$moderator,$moderatee) = split(/::/,$command[0]);

   if(!$adminyes) {
      &admin_header;
      print "$bad_password\n";
      &admin_footer;
      &unlock;
      exit;
   }
   else {
      if($adname eq "edit commands" && ! $change) {
         &admin_header;
         print "$edit_commands<br><textarea rows=10 cols=70";
         print " name=\"message\">command\::$apassword\::edit ";
         print "commands::changed\::\n";

         open(COMMANDS,"$file_dir/commands.txt");
         while(<COMMANDS>) {
            print "$_";
         }
         close(COMMANDS);

         print "</textarea><br>\n";
         print "<input type=hidden name=\"name\" value=\"$name\">\n";
         print "<input type=submit value=\"$edit_button\">";
         &admin_footer;
         &unlock;
         exit;
      }
      elsif($adname eq "edit commands" && $change eq "changed") {
         shift(@command);
         open(COMMANDS,">$file_dir/commands.txt");
         foreach$line(@command){
            if($line ne "\n") {
               print COMMANDS "$line";
            }
         }
         close(COMMANDS);
         &admin_header;
         print "$commands_edited\n";
         &admin_footer;
         &unlock;
         exit;
      }
      elsif($adname eq "moderate room") {
         $comorig = $comtime;
         if($comtime) {
            $comtime = ($comtime * 60) + $time;
         }
         open(COMMANDS,">>$file_dir/commands.txt");
         print COMMANDS "$adname\::$change\::$comtime\::$moderator\::$moderatee\n";
         close(COMMANDS);
         
         &admin_header;
         if($comtime) {
            print "$change $moderated_for $comorig $moderated_minutes.<p>\n";
         }
         else {
            print "$change $moderated_until<p>\n";
         }
         print "$moderator_is $moderator.<p>\n";
         print "$moderatee_is $moderatee.<p>\n";
         
         print "$other_posts $moderator.<p>\n";
         
         print "$only_one_on_one $moderatee<p>\n";
         &admin_footer;
         exit;
      }
      elsif($adname eq "remove message") {
         $messtime = $change;
         $lengthtime = length($messtime);
         open(MAIN,"$file_dir/chat$room");
         @main = <MAIN>;
         close(MAIN);
         open(TEMP,">$file_dir/temp$room");
         foreach$line(@main) {
            ($bogus,$linetime) = split(/:/,$line);
            $linetime = substr($linetime, -5, $lengthtime);
            if($messtime ne $linetime) {
               print TEMP $line;
            }
            else {
               $removecount++;
               push(@removed,$line);
            }
         }
         close(TEMP);
         rename("$file_dir/temp$room","$file_dir/chat$room");
         
         &admin_header;
         print "$removecount messages were removed.<p>";
         print @removed;
         &admin_footer;
         exit;
      }
      else {
         open(COMMANDS,">>$file_dir/commands.txt");
         if (! $comtime) {
            print COMMANDS "$adname\::$change\n";
         }
         else {
            $comtime = ($comtime * 60) + $time;
            print COMMANDS "$adname\::$change\::$comtime\n";
         }
         close(COMMANDS);

         &admin_header;
         print "$command_added\n";
         &admin_footer;
         &unlock;
         exit;
     }
   }
}

sub apply_commands {
   open(COMMANDS,"$file_dir/commands.txt");
   @commands = <COMMANDS>;
   close(COMMANDS);

   $room =~ s/ /_/g;
   $pubroom =~ s/ /_/g;
   $priroom =~ s/ /_/g;
   
   open(COMMANDS,">$file_dir/commands.txt");
   foreach$command(@commands){
      $command =~ s/\n//g;
      ($ofname,$change,$comtime,$moderator,$moderatee) = split(/::/,$command);
      if ($ofname eq $name) {
         @changes = split(/==/,$change);
         foreach$order(@changes) {
            ($changename,$changevalue) = split(/=/,$order);
            $FORM{$changename} = $changevalue;
         }
         if($time < $comtime) {
            print COMMANDS "$command\n";
         }
         &get_variables;
      }
      elsif ($ofname eq "archive room" && ($change eq "$room" || $change eq "$priroom" || $change eq "$pubroom")){
         open(ARCHIVE,">>$archive_dir/$change.html");
         if($where eq "register"){
            print ARCHIVE "<b>$name</b> $joined_chat $archive_date<hr>\n";
         }
         elsif($where eq "$leave_text"){
            print ARCHIVE "<b>$name</b> $left_chat $archive_date<br><hr>\n";
         }
         elsif($where eq "$go_there" && $change eq "$room" && ($pubroom || $priroom)){
            print ARCHIVE "<b>$name</b> $left_room $archive_date<br><hr>\n";
         }
         elsif($where eq "$go_there" && ($change eq "$priroom" || $change eq "$pubroom")){
            print ARCHIVE "<b>$name</b> $joined_chat $archive_date<br><hr>\n";
         }
         elsif($where eq "$post_text" && $tempmessage && !$solo){
            print ARCHIVE "<b>$name</b> $archive_date<br> $message<hr>\n";
         }
         close(ARCHIVE);            
         if($time < $comtime || ! $comtime) {
            print COMMANDS "$command\n";
         }
      }        
      elsif($ofname eq "moderate room") {
         if($solo eq "$moderatee" && $name ne "$moderator") {
            $solo = $moderator;
         }
         if($name ne "$moderator" && $name ne "$moderatee") {
            if($room eq "$change" && !$solo && $message) {
               $solo = $moderator;
            }
         }
         print COMMANDS "$command\n";
      }
      elsif($time < $comtime || ! $comtime) {
         print COMMANDS "$command\n";
      }
   }
   close(COMMANDS);
   
}
sub admin_header {
   print "Content-type: text/html\n\n";
   print "<html><head><title>$page_title</title></head>\n";
   
   print "<body bgcolor=$bgcolor background=\"$background\" ";
   print "text=$text_color link=$link_color vlink=$vlink_color>\n";
   print "<center>\n";
   
   if ($title_graphic eq "") {
      print "<H1>$page_title</h1>\n";
   }
   else {
      print "<h1><img src=\"$title_graphic\" alt=\"$page_title\"></h1>\n";
   }
   
   print "</center><hr>";
   print "<form method=post action=\"$ENV{'SCRIPT_NAME'}\">\n";
   print "<input type=hidden name=\"nummes\" value=\"$nummes\">\n";
   print "<input type=hidden name=\"room\" value=\"$room\">\n";
   print "<input type=hidden name=\"name\" value=\"$name\">\n";
   print "<input type=hidden name=\"password\" value=\"$password\">\n";
   print "<input type=hidden name=\"passwd\" value=\"$passwd\">\n";
   print "<input type=hidden name=\"where\" value=\"$go_there\">\n";
   print "<input type=hidden name=\"mail\" value=\"$mail\">\n";
   print "<input type=hidden name=\"frames\" value=\"$frames\">\n";
   print "<input type=hidden name=\"link\" value=\"$link\">\n";
   print "<input type=hidden name=\"ignored\" value=\"$ignoredlist\">\n";
   print "<input type=hidden name=\"load_time\" value=\"$load_time\">\n";
   if($adminyes) {
      print "<input type=\"hidden\" name=\"admin\" value=\"1\">\n";
   }
}
sub admin_footer {
   print "<hr>\n";
   if($message !~ /edit commands/) {
      print "<input type=\"submit\" value=\"$return_text\"></form></center><hr>\n";
   }  
   print "<center>$our_image</center>\n";
   print "</body> </html>\n";
}
############################################
# DO NOT CHANGE THE LAST LINE OF THIS FILE #
############################################
1;
